<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"> 
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="language" content="en" />
<link rel="stylesheet" type="text/css" href="<?php echo Yii::app()->request->baseUrl; ?>/css/main.css" />
<link rel="shortcut icon" href="<?php echo Yii::app()->request->baseUrl; ?>/css/images/favicon.ico" type="image/x-icon" />
<title><?php echo Yii::t('app',"Access denied"); ?></title>
</head>

<body>
<div id="page">

<div id="header">
<?php 
    Yii::app()->getClientScript()->registerCssFile(Yii::app()->request->baseUrl."/css/main.css");
    
    echo CHtml::image( 'images/fusion.png', "Fusion", array('class'=>'main_logo') ); 
?>
</div> <!-- header -->

<div id="top-menu" > 

<?php 

echo CHtml::openTag("ul", array('class'=>'menu-item empty'));
echo CHtml::tag("li", array(), CHtml::link("Home", CHtml::normalizeUrl(array("/users", 'refresh'=>'1') ), array('class'=>'icon_link navi')) ); 
echo CHtml::closeTag("ul");

?>

</div> <!-- top-menu -->

<div id="content">

<?php
    echo CHtml::openTag("div", array( "class"=>"welcome_section" ) );
    LayoutHelper::openBorders();
    echo CHtml::openTag("div", array( "class"=>"welcome_section_inside" ) );
    if ( !Yii::app()->user->activated ) {
        echo CHtml::tag("h1", array('class'=>'errorSummary httperror'), Yii::t('app',"Fusion not activated") );
        
        echo CHtml::tag("h2", array('class'=>'httperror'), 
                            CHtml::link(   Yii::t('app',"Please open Control Center to activate Fusion"),
                                        "/index.php?r=admin/fusion",
                                        array( )                               
                            )
                    );
        
    } else {
        echo CHtml::tag("h1", array('class'=>'errorSummary httperror'), Yii::t('app',"Access denied") );
        
        echo CHtml::tag("h2", array('class'=>'httperror'), nl2br(CHtml::encode($data['message'])) );

        echo CHtml::tag("p", array('class'=>'httperror'), 
                        Yii::t('app',"You do not have the proper credentials to access this page.") 
                        );
        echo CHtml::tag("p", array('class'=>'httperror'), 
                        nl2br(CHtml::encode( Yii::t('app',"If you think this is a server error, please contact ").$data['admin'] ))
                        );
    }
    echo CHtml::closeTag("div")."\n"; //welcome_section_inside
    LayoutHelper::closeBorders();
    echo CHtml::closeTag("div")."\n"; //welcome_section
?>
</div><!-- main_area -->


<?php 
echo CHtml::openTag('div',  array('id'=>'footer') );

LayoutHelper::openBorders();

echo CHtml::openTag('div',  array('class'=>'footer-content') );

if ( file_exists('/etc/spinetix-release') ) {
	$release = file_get_contents('/etc/spinetix-release');
	$vals=explode(" ", $release);
	$firmware = "x.x.x";
	$build = "x.x.x";
	if (count($vals)==6 ){
		$firmware = $vals[3];
		$build = $vals[5];
	}
	echo CHtml::tag("span", array('class'=>'firmware'), "v ".$firmware. " - ".$build);
}

echo CHtml::tag("span", array('class'=>'copyrights'), "Copyright &copy; SpinetiX AG. All Rights Reserved.");

echo CHtml::closeTag("div");

LayoutHelper::closeBorders();

echo CHtml::closeTag("div");

?>

</div> <!-- id="page" -->
</body>

</html>